###############################################################################
# BoardIndex.pl                                                               #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
###############################################################################

sub BoardIndex {
	# Open the file with all categories
	open(FILE, "$vardir/cat.txt");
	&lock(FILE);
	@categories = <FILE>;
	&unlock(FILE);
	close(FILE);
	$title = "$txt{'18'}";
	open(FILE, "$memberdir/memberlist.txt");
	&lock(FILE);
	@memberlist = <FILE>;
	&unlock(FILE);
	$memcount = @memberlist;
	close(FILE);
	# First we're going to count how many threads and messages are posted
	$totalm=0;
	$totalt=0;
	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;
		open(CAT, "$boardsdir/$curcat.cat");
		&lock(CAT);
		@catinfo = <CAT>;
		&unlock(CAT);
		close(CAT);
		$catinfo[1] =~ s/[\n\r]//g;
		if($catinfo[1] ne "") {
			if($settings[7] ne "Administrator" && $settings[7] ne "$catinfo[1]") {
				next;
			}
		}
		$curcatname="$catinfo[0]";
		foreach $curboard (@catinfo) {
			if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
				$curboard =~ s/[\n\r]//g;
				open(BOARDDATA, "$boardsdir/$curboard.txt");
				&lock(BOARDDATA);
				@messages = <BOARDDATA>;
				&unlock(BOARDDATA);
				close(BOARDDATA);
				$tm = @messages;
				($dummy, $dummy, $dummy, $dummy, $lp) = split(/\|/, $messages[0]);
				$boardinfo[2] =~ s/[\n\r]//g;
				$messagecount=0;
				for ($a = 0; $a < @messages; $a++) {
					($dm,$dm,$dm,$dm,$dm,$mreplies,$dm) = split(/\|/,$messages[$a]);
					$messagecount++;
					$messagecount=$messagecount+$mreplies;
				}
				if($lp eq "") { $lp="N/A"; }
				$totalm=$totalm+$messagecount;
				$totalt=$totalt+$tm;
			}
		}
	}
	# Now we're printing the categories and boards
	&header;
	&welcome;
	print <<"EOT";
<table width=100%>
<tr>
	<td valign=bottom><font size=2><b><a href="$boardurl/YaBB.pl">$mbname</a></b></font></td>
	<td align=right><font size=2>$txt{'19'}: $memcount<br>
$txt{'94'} $totalm $txt{'95'} $totalt $txt{'64'}<br>$thelatestmember</font></td>
</tr>
</table>
<table border=0 width=100% cellspacing=1 bgcolor="#000000">
<tr>
	<td bgcolor="$color{'titlebg'}" width=10><font size=2>&nbsp;</font></td>
	<td bgcolor="$color{'titlebg'}"><font color="$color{'titletext'}" size=2><b>$txt{'20'}</b></font></td>
	<td bgcolor="$color{'titlebg'}" nowrap align=center><font color="$color{'titletext'}" size=2><b>Threads</b></font></td>
	<td bgcolor="$color{'titlebg'}" nowrap align=center><font color="$color{'titletext'}" size=2><b>$txt{'21'}</b></font></td>
	<td bgcolor="$color{'titlebg'}" nowrap align=center><font color="$color{'titletext'}" size=2><b>$txt{'22'}</b></font></td>
	<td bgcolor="$color{'titlebg'}" nowrap><font color="$color{'titletext'}" size=2><b>$txt{'12'}</b></font></td>
</tr>
EOT
	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;
		open(CAT, "$boardsdir/$curcat.cat");
		&lock(CAT);
		@catinfo = <CAT>;
		&unlock(CAT);
		close(CAT);
		$catinfo[1] =~ s/[\n\r]//g;
		if($catinfo[1] ne "") {
			if($settings[7] ne "Administrator" && $settings[7] ne "$catinfo[1]") {
				next;
			}
		}
		$curcatname="$catinfo[0]";
		print <<"EOT";
<tr>
	<td bgcolor="$color{'catbg'}" width=10 valign=top><img src="$imagesdir/cat.gif" width=18 height=18 alt="" border="0"></td>
	<td colspan=5 bgcolor="$color{'catbg'}"><font size=2><b>$curcatname</b></font></td>
</tr>
EOT
		foreach $curboard (@catinfo) {
			# Open the categegory file and list all boards in it
			if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
				$curboard =~ s/[\n\r]//g;
				open(BOARD, "$boardsdir/$curboard.dat");
				&lock(BOARD);
				@boardinfo = <BOARD>;
				&unlock(BOARD);
				close(BOARD);
				$curboardname="$boardinfo[0]";
				$descr="$boardinfo[1]";
				open(BOARDDATA, "$boardsdir/$curboard.txt");
				&lock(BOARDDATA);
				@messages = <BOARDDATA>;
				&unlock(BOARDDATA);
				close(BOARDDATA);
				$tm = @messages;
				if(@messages == 0) { $tm="<font size=-1>N/A</font>"; }
				($dummy, $dummy, $dummy, $dummy, $lp) = split(/\|/, $messages[0]);
				$boardinfo[2] =~ s/[\n\r]//g;
				$messagecount=0;
				for ($a = 0; $a < @messages; $a++) {
					($dm,$dm,$dm,$dm,$dm,$mreplies,$dm) = split(/\|/,$messages[$a]);
					$messagecount++;
					$messagecount=$messagecount+$mreplies;
				}

				%moderators = ();
					
				foreach(split(/\|/,$boardinfo[2])) {

					open(MODERATOR, "$memberdir/$_.dat");
					&lock(MODERATOR);
					@modprop = <MODERATOR>;
					&unlock(MODERATOR);
					close(MODERATOR);
					$modprop[1] =~ s/[\n\r]//g;
					
					$moderators{$_} = $modprop[1]; 
				}

				$showmods = "";
				
				foreach $muname (keys %moderators) {
				        $showmods .= "<a href=\"$boardurl/YaBB.pl?board=&action=viewprofile&username=$muname\">$moderators{$muname}</a>, ";
				}
			
				$showmods =~ s/, $//;

				if($lp eq "") { $lp="N/A"; }
				$dlp = &readlog("$curboard");
				$new="";
				if($dlp ne "$lp" && $lp ne "N/A" && $username ne "Guest") {
					$new = "<img src=\"$imagesdir/new.gif\" width=28 heigt=11 alt=\"New\">";
				}
				print <<"EOT";
<tr>
	<td bgcolor="$color{'windowbg2'}" width=10 valign=top><img src="$imagesdir/board.gif" width=16 height=16 alt="" border="0"></td>
	<td bgcolor="$color{'windowbg2'}" width=* valign=top><font size=2><b><a href="YaBB.pl?board=$curboard">$curboardname</a>$new</b><br>
	$descr</font></td>
	<td bgcolor="$color{'windowbg2'}" valign=top width=15% align=center><font size=2>$tm</font></td>
	<td bgcolor="$color{'windowbg2'}" valign=top width=15% align=center><font size=2>$messagecount</font></td>
	<td bgcolor="$color{'windowbg2'}" valign=top width=15% align=center><font size=1>$lp</font></td>
	<td bgcolor="$color{'windowbg2'}" valign=top width=20%><font size=2>$showmods</font></td>
</tr>
EOT
			}
		}
	}
	$guests=0;
	$users="";
	open(LOG, "$vardir/log.txt");
	&lock(LOG);
	@entries = <LOG>;
	&unlock(LOG);
	close(LOG);
	foreach $curentry (@entries) {
		$curentry =~ s/[\n\r]//g;
		($name, $value) = split(/\|/, $curentry);
		if($name =~ /\./) { ++$guests }
		else {
			open(MEM, "$memberdir/$name.dat");
			&lock(MEM);
			@sett = <MEM>;
			&unlock(MEM);
			close(MEM);
			$sett[1] =~ s/[\n\r]//g;
			$users = "$users <a href=\"$cgi\&action=viewprofile\&username=$name\">$sett[1]</a>\n"; }
	}
if($username ne "Guest") { 
		open(IM, "$memberdir/$username.msg"); 
		&lock(IM); 
		@immessages = <IM>; 
		&unlock(IM); 
		close(IM); 
		$mnum = @immessages; 
		$messnum = "$mnum"; 
}
if($mnum eq "1") { 
		$s = "" 
} 
	else { 
		$s ="" 
}

	print <<"EOT";
<tr>
	<td colspan=6 bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}"><b>Members</b></font></td>
</tr>
<tr>
	<td bgcolor="$color{'windowbg2'}" width=10 valign=middle align=center><img src="$imagesdir/online.gif" alt="online" border="0"></td>
	<td bgcolor="$color{'windowbg2'}" valign=top colspan=5><font size=2><b><A href="YaBB.pl?action=mltop">Members List</A></b></font><br><font size=1>$txt{'200'}</font>
</td>
</tr>
<tr>
	<td colspan=6 bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}"><b>$txt{'158'}</b></font></td>
</tr>
<tr>
	<td bgcolor="$color{'windowbg2'}" width=10 valign=middle align=center><img src="$imagesdir/online.gif" alt="online" border="0"></td>
	<td bgcolor="$color{'windowbg2'}" valign=top colspan=5><font size=2>$txt{'141'}: $guests <br>$txt{'142'}: $users</font></td>
</tr>
EOT
	if($username ne "Guest") {
		print <<"EOT";
<tr>
	<td colspan=6 bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}"><b>$txt{'159'}</b></font></td>
</tr>
<tr>
	<td bgcolor="$color{'windowbg2'}" width=10 valign=middle align=center><img src="$imagesdir/pmon.gif" alt="" border="0"></td>
	<td bgcolor="$color{'windowbg'}" valign=top colspan=5><font size=2><b><a href=\"$cgi\&action=im\">$txt{'153'}</a></b></font><br><font size=1>$txt{'152'} $mnum $txt{'153'}$s</font>
</td>
</tr>
EOT
	}
print <<"EOT";
</table> 
EOT
	&footer;
	exit;
}

sub welcome {
open(MEMBERSLISTREAD,"$memberdir/memberlist.txt");
	while(chomp($membername=<MEMBERSLISTREAD>)) {
		@member = ();
		open(MEMBERFILEREAD,"$memberdir/$membername.dat");
		@member = <MEMBERFILEREAD>;
		close(MEMBERFILEREAD);
		chomp @member;

		$thelatestmember = "$txt{'201'}: <a href=\"$boardurl/YaBB.pl?board=\&action=viewprofile\&username=$membername\"><b>$member[1]</b></a>";
		
	} # end while
close(MEMBERSLISTREAD);
} # end sub welcome

1;