###############################################################################
# InstantMessage.pl                                                           #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
# =========================================================================== #
###############################################################################
# $field[0] = From (username only)
# $field[1] = Subject
# $field[2] = Date
# $field[3] = Message
# $field[4] = MessageID
# $field[5] = IP

sub IMIndex {

	if ($username eq "Guest") { 
		&fatal_error("$txt{'147'}"); 
	}
	
	# Read all messages
	
	open(FILE, "$memberdir/$username.msg");
	&lock(FILE);
	@messages = <FILE>;
	&unlock(FILE);
	close(FILE);
	
	# Read Membergroups
	
	$title = "$txt{'143'}";
	open(FILE, "$vardir/membergroups.txt");
	&lock(FILE);
	@membergroups = <FILE>;
	&unlock(FILE);
	close(FILE);
	
	# Read list of censored words
	
	open(CENSOR, "$vardir/censor.txt");
	&lock(CENSOR);
	@censored = <CENSOR>;
	&unlock(CENSOR);
	close(CENSOR);
	
	########################################################################
	
	&header;

	########################################################################
	
	$imtxt{'1'} = "Inbox";
	$imtxt{'2'} = "Date";
	$imtxt{'3'} = "From";
	$imtxt{'4'} = "Subject";
	$imtxt{'5'} = "Outbox";
	
	print <<"EOT";
<table border=0 width=100% cellspacing=0>
<tr>
<td valign=bottom>
<font size=2>
 <b><a href="$boardurl/YaBB.pl">$mbname</a>:
    <a href="$cgi&action=im">$txt{'144'}</a>: $imtxt{'1'}</b>
</font>
</td>
<td align=right>
EOT
	print "<img src=\"$imagesdir/im_left.gif\" border=0 width=16 height=52>";
	print <<"EOT";
<a href="$cgi&action=imoutbox"><img src="$imagesdir/im_outbox.gif" border=0 width=37 height=52 alt="$imtxt{'5'}"></a><a href="$cgi&action=imsend"><img src="$imagesdir/im_new.gif" width=37 height=52 border=0 alt="New Message"></a><a href="$cgi&action=im"><img src="$imagesdir/im_reload.gif" border=0 width=37 height=52 alt="Receive New Messages"></a><a href="$cgi&action=imprefs"><img src="$imagesdir/im_config.gif" border=0 width=37 height=52 alt="Preferences"></a><img src="$imagesdir/im_right.gif" border=0 width=76 height=52>
</td>
</table>
<table border=0 width=100% cellspacing=1 bgcolor="#000000">
<tr>
 <td bgcolor="$color{'titlebg'}" width=140><font size=2 color="$color{'titletext'}">&nbsp;<b>$imtxt{'2'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}"><b>$imtxt{'3'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}"><b>$imtxt{'4'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}">&nbsp;</font></td>
</tr>
EOT

	# Display Message if there are no Messages in Users Inbox	

	if(@messages==0) {
		print <<"EOT";
<tr>
	<td colspan=4 bgcolor="$color{'windowbg'}"><font size=2>$txt{'151'}</font></td>
</tr>
EOT
	}	
	
	# Display all available Messages

	$second="$color{'windowbg2'}";

	for ($a = 0; $a < @messages; $a++) {

		if($second eq "$color{'windowbg'}") { 
			$second="$color{'windowbg2'}"; 
		} else { 
			$second="$color{'windowbg'}"; 
		}
		
		($musername[$a], $msub[$a], $mdate[$a], $mmessage[$a], $messageid[$a], $mips[$a]) = split(/\|/,$messages[$a]);

                # Lets set ID to $a if we've got an old message
                
                if ($messageid[$a] < 100) {
			$messageid[$a] = $a;      	
                }

		$name = "$mname[$a]";
		$date = "$mdate[$a]";
		$subject = "$msub[$a]";

		if($subject eq "") { 
			$subject="$txt{'24'}"; 
		}

		print "<tr>";
                print "<td bgcolor=\"$second\">$date</td>";
                print "<td bgcolor=\"$second\">$musername[$a]</td>";
                print "<td bgcolor=\"$second\"><a href=\"#$messageid[$a]\">$subject</a></td>";
		print "<td bgcolor=\"$second\"><a href=\"$cgi&action=imremove&caller=1&id=$messageid[$a]\">delete</a></td>";
		print "</tr>";

	}

print <<"EOT";
</table>
EOT

	########################################################################
	# Output all messages

	if(@messages!=0) {

	print <<"EOT";
<br>
<table border=0 width=100% cellspacing=1 bgcolor="#000000">
<tr>
 <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}">&nbsp;<b>$txt{'29'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}"><b>$txt{'118'}</b></font></td>
</tr>
EOT

	if(@messages==0) {
		print <<"EOT";
<tr>
	<td colspan=2 bgcolor="$color{'windowbg'}"><font size=2>$txt{'151'}</font></td>
</tr>
EOT
	}

	$second="$color{'windowbg2'}";

	for ($a = 0; $a < @messages; $a++) {
		if($second eq "$color{'windowbg'}") { 
			$second="$color{'windowbg2'}"; 
		} else { 
			$second="$color{'windowbg'}"; 
		}
		
		($musername[$a], $msub[$a], $mdate[$a], $mmessage[$a], $messageid[$a]) = split(/\|/,$messages[$a]);

                # Lets set ID to $a if we've got an old message
                
                if ($messageid[$a] < 100) {
			$messageid[$a] = $a;      	
                }

		$subject = "$msub[$a]";

		if($subject eq "") { 
			$subject="$txt{'24'}"; 
		}
		
		$mmessage[$a] =~ s/[\n\r]//g;
		$message="$mmessage[$a]";
		$name = "$mname[$a]";
		$date = "$mdate[$a]";
		$ip = "$mip[$a]";
		$postinfo="";
		$signature="";
		$viewd="";
		$icq="";
		$star="";
		
		open(FILE, "$memberdir/$musername[$a].dat");
		&lock(FILE);
		@memset = <FILE>;
		&unlock(FILE);
		close(FILE);
		
		$postinfo = "$txt{'26'}: $memset[6]<br>";
		$viewd = " \| <a href=\"$cgi\&action=viewprofile\&username=$musername[$a]\">$txt{'27'}</a><br>";
		$memberinfo = "$membergroups[2]";
		$star="<img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\">";
		if($memset[6] > 50) {
			$memberinfo = "$membergroups[3]";
			$star="<img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\">";
		}
		if($memset[6] > 100) {
			$memberinfo = "$membergroups[4]";
			$star="<img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\">";
		}
		if($memset[6] > 250) {
			$memberinfo = "$membergroups[4]";
			$star="<img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\">";
		}
		if($memset[6] > 500) {
			$memberinfo = "$membergroups[4]";
			$star="<img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\">";
		}
		if($boardmoderator eq "$musername[$a]") { $memberinfo = "$membergroups[1]"; }
		if($memset[7] ne "\n") { $memberinfo = "$memset[7]"; }
		if($memberinfo eq "$Administrator\n") { $memberinfo = "$membergroups[0]"; }
		$signature = "$memset[5]";
		$signature =~ s/\&\&/<br>/g;
		$signature = "<hr width=40\% align=left>$signature";
		$memset[8] =~ s/[\n\r]//g;
		if($memset[8] ne "") {
                if(!($memset[8] =~ /\D/)) { 
			$icq="<a href=\"javascript:openScript('$cgi\&action=icqpager&UIN=$memset[8]',450,300)\"><img src=\"http://wwp.icq.com/scripts/online.dll?icq=$memset[8]&img=5\" alt =\"$memset[8]\" border=0></a>";
			#$icq = "<a href=\"http://www.icq.com/$memset[8]\" target=_blank><img src=\"http://wwp.icq.com/scripts/online.dll?icq=$memset[8]&img=5\" alt =\"$memset[8]\" border=0></a>";
		}
		}
		$message = "$message\n$signature";
		if($enable_ubbc) {
			require "$sourcedir/Display.pl";
			&DoUBBC;
		}
		$url="";
		if($memset[3] ne "\n" && $musername[$a] ne "Guest") {
			$url= "<a href=\"$memset[4]\">WWW</a> \| ";
		}
		##################
		foreach $censor (@censored) {
			$censor =~ s/\n//g;
			($word, $censored) = split(/\=/, $censor);
			$message =~ s/$word/$censored/g;
			$subject =~ s/$word/$censored/g;
		}
		##################
		print <<"EOT";
<tr>
	<td bgcolor="$second" width=140 valign=top rowspan=2>
	<font size=2><b>$memset[1]</b></font><br>
	<font size=1>$memberinfo<br>
	$star<br><br>
	$postinfo<br>
	$icq
	</font></td>
	<td bgcolor="$second" valign=top>
	<table border=0 cellspacing=0 cellpadding=0 width=100%>
<tr>
	<td width=100%><a name="$messageid[$a]"><font size=1>&nbsp;<b>$subject</b></font></td>
	<td align=right nowrap><font size=1><b>$txt{'30'}:</b> $date</font></td>
</tr>
</table>
	<hr></font>
<font size=2>
$message
</font></td>
</tr>
<tr>
	<td bgcolor="$second"><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td><font size=1>
$url<a href="mailto:$memset[2]">E-Mail</a>$viewd
</font></td><td align=right>
<font size=1><a href="$cgi&action=imsend&caller=1&num=$a&quote=1&to=$musername[$a]">$txt{'145'}</a> | <a href="$cgi&action=imsend&caller=1&to=$musername[$a]&num=$a">$txt{'146'}</a> | <a href="$cgi&action=imremove&caller=1&caller=1&id=$messageid[$a]"><b>$txt{'154'}</b></a></font></td></tr></table></td>
</tr>
EOT
;
	}
	print <<"EOT";
</table>
<font size=2><a href="$cgi&action=imsend">$txt{'148'}</a></font>
EOT
}
	&footer;
	exit;
}

sub IMOutbox {

	if ($username eq "Guest") { 
		&fatal_error("$txt{'147'}"); 
	}
	
	open(FILE, "$memberdir/$username.dat");
	&lock(FILE);
	@memset = <FILE>;
	&unlock(FILE);
	close(FILE);

	# Read all messages
	
	open(FILE, "$memberdir/$username.outbox");
	&lock(FILE);
	@messages = <FILE>;
	&unlock(FILE);
	close(FILE);
	
	# Read Membergroups
	
	$title = "$txt{'143'}";
	open(FILE, "$vardir/membergroups.txt");
	&lock(FILE);
	@membergroups = <FILE>;
	&unlock(FILE);
	close(FILE);
	
	# Read list of censored words
	
	open(CENSOR, "$vardir/censor.txt");
	&lock(CENSOR);
	@censored = <CENSOR>;
	&unlock(CENSOR);
	close(CENSOR);
	
	##################
	
	&header;

	#####

	$imtxt{'1'} = "Outbox";
	$imtxt{'2'} = "Date";
	$imtxt{'3'} = "To";
	$imtxt{'4'} = "Subject";
	
	print <<"EOT";
<table border=0 width=100% cellspacing=0>
<tr>
<td valign=bottom>
<font size=2>
 <b><a href="$boardurl/YaBB.pl">$mbname</a>:
    <a href="$cgi&action=im">$txt{'144'}</a>: $imtxt{'1'}</b>
</font>
</td>
<td align=right>
EOT
	print "<img src=\"$imagesdir/im_left.gif\" border=0 width=16 height=52>";
	if ($INFO{'id'} > 0) {
		print "<a href=\"$cgi&action=imsend&num=$INFO{'num'}&quote=2\"><img src=\"$imagesdir/im_forward.gif\" border=0 width=37 height=52 alt=\"Forward\"></a>";
		print "<a href=\"$cgi&action=imremove&caller=2&id=$INFO{'id'}\"><img src=\"$imagesdir/im_delete.gif\" border=0 width=37 height=52 alt=\"Delete\"></a>";
		print "<img src=\"$imagesdir/im_spacer.gif\" border=0 width=10 height=52>";
	}
	print <<"EOT";
<a href="$cgi&action=im"><img src="$imagesdir/im_inbox.gif" border=0 width=37 height=52 alt="Inbox"></a><a href="$cgi&action=imsend"><img src="$imagesdir/im_new.gif" width=37 height=52 border=0 alt="New Message"></a><a href="$cgi&action=im"><img src="$imagesdir/im_reload.gif" border=0 width=37 height=52 alt="Receive New Messages"></a><a href="$cgi&action=imprefs"><img src="$imagesdir/im_config.gif" border=0 width=37 height=52 alt="Preferences"></a><img src="$imagesdir/im_right.gif" border=0 width=76 height=52>
</td>
</table>
<table border=0 width=100% cellspacing=1 bgcolor="#000000">
<tr>
 <td bgcolor="$color{'titlebg'}" width=140><font size=2 color="$color{'titletext'}">&nbsp;<b>$imtxt{'2'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}"><b>$imtxt{'3'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}"><b>$imtxt{'4'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}">&nbsp;</font></td>
</tr>
EOT

	# Display Message if there are no Messages in Users Outbox	

	if(@messages==0) {
		print <<"EOT";
<tr>
	<td colspan=4 bgcolor="$color{'windowbg'}"><font size=2>$txt{'151'}</font></td>
</tr>
EOT
	}	
	
	# Display all available Messages

	$second="$color{'windowbg2'}";

	for ($a = 0; $a < @messages; $a++) {

		if($second eq "$color{'windowbg'}") { 
			$second="$color{'windowbg2'}"; 
		} else { 
			$second="$color{'windowbg'}"; 
		}
		
		($musername[$a], $msub[$a], $mdate[$a], $mmessage[$a], $messageid[$a], $mips[$a]) = split(/\|/,$messages[$a]);

                # Lets set ID to $a if we've got an old message
                
                if ($messageid[$a] < 100) {
			$messageid[$a] = $a;      	
                }

		$name = "$mname[$a]";
		$date = "$mdate[$a]";
		$subject = "$msub[$a]";

		if($subject eq "") { 
			$subject="$txt{'24'}"; 
		}

		print "<tr>";
                print "<td bgcolor=\"$second\">$date</td>";
                print "<td bgcolor=\"$second\">$musername[$a]</td>";
                print "<td bgcolor=\"$second\"><a href=\"#$messageid[$a]\">$subject</a></td>";
		print "<td bgcolor=\"$second\"><a href=\"$cgi&action=imremove&caller=2&id=$messageid[$a]\">delete</a></td>";
		print "</tr>";

	}

print <<"EOT";
</table>
EOT

	#####

	# Output all messages

	if(@messages!=0) {

	print <<"EOT";
<br>
<table border=0 width=100% cellspacing=1 bgcolor="#000000">
<tr>
 <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}">&nbsp;<b>$txt{'29'}</b></font></td>
 <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}"><b>$txt{'118'}</b></font></td>
</tr>
EOT

	if(@messages==0) {
		print <<"EOT";
<tr>
	<td colspan=2 bgcolor="$color{'windowbg'}"><font size=2>$txt{'151'}</font></td>
</tr>
EOT
	}

	$second="$color{'windowbg2'}";

	for ($a = 0; $a < @messages; $a++) 
	{
		if($second eq "$color{'windowbg'}") 
		{ 
			$second="$color{'windowbg2'}"; 
		}
		else 
		{ 
			$second="$color{'windowbg'}"; 
		}
		
		($musername[$a], $msub[$a], $mdate[$a], $mmessage[$a], $messageid[$a]) = split(/\|/,$messages[$a]);

                # Lets set ID to $a if we've got an old message
                
                if ($messageid[$a] < 100) {
			$messageid[$a] = $a;      	
                }

		$subject = "$msub[$a]";

		if($subject eq "") { 
			$subject="$txt{'24'}"; 
		}
		
		$mmessage[$a] =~ s/[\n\r]//g;
		$message="$mmessage[$a]";
		$name = "$mname[$a]";
		$date = "$mdate[$a]";
		$ip = "$mip[$a]";
		$postinfo="";
		$signature="";
		$viewd="";
		$icq="";
		$star="";
				
		$postinfo = "$txt{'26'}: $memset[6]<br>";
		$viewd = " \| <a href=\"$cgi\&action=viewprofile\&username=$musername[$a]\">$txt{'27'}</a><br>";
		$memberinfo = "$membergroups[2]";
		$star="<img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\">";
		if($memset[6] > 50) {
			$memberinfo = "$membergroups[3]";
			$star="<img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\">";
		}
		if($memset[6] > 100) {
			$memberinfo = "$membergroups[4]";
			$star="<img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\">";
		}
		if($memset[6] > 250) {
			$memberinfo = "$membergroups[4]";
			$star="<img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\">";
		}
		if($memset[6] > 500) {
			$memberinfo = "$membergroups[4]";
			$star="<img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\"><img src=\"$imagesdir/star.gif\" width=13 height=12 alt=\"\" border=\"0\">";
		}
		if($boardmoderator eq "$musername[$a]") { $memberinfo = "$membergroups[1]"; }
		if($memset[7] ne "\n") { $memberinfo = "$memset[7]"; }
		if($memberinfo eq "$Administrator\n") { $memberinfo = "$membergroups[0]"; }
		$signature = "$memset[5]";
		$signature =~ s/\&\&/<br>/g;
		$signature = "<hr width=40\% align=left>$signature";
		$memset[8] =~ s/[\n\r]//g;
		if($memset[8] ne "") {
                if(!($memset[8] =~ /\D/)) { 
			$icq="<a href=\"javascript:openScript('$cgi\&action=icqpager&UIN=$memset[8]',450,300)\"><img src=\"http://wwp.icq.com/scripts/online.dll?icq=$memset[8]&img=5\" alt =\"$memset[8]\" border=0></a>";
			#$icq = "<a href=\"http://www.icq.com/$memset[8]\" target=_blank><img src=\"http://wwp.icq.com/scripts/online.dll?icq=$memset[8]&img=5\" alt =\"$memset[8]\" border=0></a>";
		}
		}
		$message = "$message\n$signature";
		if($enable_ubbc) {
			require "$sourcedir/Display.pl";
			&DoUBBC;
		}
		$url="";
		if($memset[3] ne "\n" && $musername[$a] ne "Guest") {
			$url= "<a href=\"$memset[4]\">WWW</a> \| ";
		}
		##################
		foreach $censor (@censored) {
			$censor =~ s/\n//g;
			($word, $censored) = split(/\=/, $censor);
			$message =~ s/$word/$censored/g;
			$subject =~ s/$word/$censored/g;
		}
		##################
		print <<"EOT";
<tr>
	<td bgcolor="$second" width=140 valign=top rowspan=2>
	<font size=2><b>$memset[1]</b></font><br>
	<font size=1>$memberinfo<br>
	$star<br><br>
	$postinfo<br>
	$icq
	</font></td>
	<td bgcolor="$second" valign=top>
	<table border=0 cellspacing=0 cellpadding=0 width=100%>
<tr>
	<td width=100%><font size=1><a name="$messageid[$a]">&nbsp;<b>$subject</b></font></td>
	<td align=right nowrap><font size=1><b>$txt{'30'}:</b> $date</font></td>
</tr>
</table>
	<hr></font>
<font size=2>
$message
</font></td>
</tr>
<tr>
	<td bgcolor="$second"><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td><font size=1>
$url<a href="mailto:$memset[2]">E-Mail</a>$viewd
</font></td><td align=right>
<font size=1><a href="$cgi&action=imsend&caller=2&num=$a&quote=1&to=$musername[$a]">$txt{'145'}</a> | <a href="$cgi&action=imsend&caller=2&to=$musername[$a]&num=$a">$txt{'146'}</a> | <a href="$cgi&action=imremove&caller=2&id=$messageid[$a]"><b>$txt{'154'}</b></a></font></td></tr></table></td>
</tr>
EOT
;
	}
	print <<"EOT";
</table>
<font size=2><a href="$cgi&action=imsend">$txt{'148'}</a></font>
EOT
}
	&footer;
	exit;
}

#####
#
# Remove Message from Inbox/Outbox
#
#####

sub IMRemove
{
	#&checkdomain;

	if($username eq "Guest") { 
		&fatal_error("$txt{'147'}"); 
	}

	if ($INFO{'caller'} == 1) {
		open(FILE, "$memberdir/$username.msg");
	} elsif ($INFO{'caller'} == 2) {
		open(FILE, "$memberdir/$username.outbox");
	}
	
	&lock(FILE);
	@messages = <FILE>;
	&unlock(FILE);
	close(FILE);

	if ($INFO{'caller'} == 1) {
		open(FILE, ">$memberdir/$username.msg");
	} elsif ($INFO{'caller'} == 2) {
		open(FILE, ">$memberdir/$username.outbox");
	}
	&lock(FILE);

	for ($a = 0; $a < @messages; $a++) {
		# ONLY delete MSG with correct ID
		($musername, $msub, $mdate, $mmessage, $messageid, $mips) = split(/\|/,$messages[$a]);

		$messageid =~ s/[\n\r]//g; # this line is necessary !!!

		# If Message-ID is < 100, user has used the old IM before
		if ($messageid < 100 ) {
			if($a ne $INFO{'id'}) { 
		    		print FILE "$messages[$a]"; 
		 	}
		} else {
         		if($messageid ne "$INFO{'id'}") { 
            			print FILE "$messages[$a]"; 
         		}
      		}
   	}

   	&unlock(FILE);
   	close(FILE);

	if ($INFO{'caller'} == 1) {
   		print "Location: $cgi\&action=im\n\n";
   	} else {
   		print "Location: $cgi\&action=imoutbox\n\n";
   	}

}

#####
#
# Write new Message
#
#####

sub IMPost {

	$imtxt{'1'} = "Inbox";
	$imtxt{'2'} = "Outbox";
	$imtxt{'3'} = "Receive New Messages";
	$imtxt{'4'} = "Preferences";

	if($username eq "Guest") { 
	 	&fatal_error("$txt{'147'}"); 
	}

	$title="$txt{'148'}";
	&header;
	if($INFO{'num'} ne "") {
	
		if($INFO{'caller'} == 1) {
			open(FILE, "$memberdir/$username.msg");
		} else {
			open(FILE, "$memberdir/$username.outbox");
		}
	
		&lock(FILE);
		@messages = <FILE>;
		&unlock(FILE);
		close(FILE);

		($mfrom, $msubject, $mdate, $mmessage, $mip) = split(/\|/,$messages[$INFO{'num'}]);
		$msubject =~ s/Re: //g;

		if($INFO{'quote'} == 1) {
			$mmessage =~ s/<br>/\n/g;
			$form_message =~ s/\[quote\](\S+?)\[\/quote\]//isg;
			$form_message =~ s/\[(\S+?)\]//isg;
			$form_message = "\n\n\[quote\]$mmessage\[/quote\]";
			$form_subject = "Re: $msubject";
		}
		
	}

	print <<"EOT";
<table border=0 width=100% cellspacing=0>
<tr>
<td valign=bottom>
<font size=2>
 <b><a href="$boardurl/YaBB.pl">$mbname</a>:
    <a href="$cgi&action=im">$txt{'144'}</a>: $imtxt{'1'}</b>
</font>
</td>
<td align=right>
EOT
	print "<img src=\"$imagesdir/im_left.gif\" border=0 width=16 height=52>";
	print <<"EOT";
<a href="$cgi&action=im"><img src="$imagesdir/im_inbox.gif" border=0 width=37 height=52 alt="$imtxt{'1'}"></a><a href="$cgi&action=imoutbox"><img src="$imagesdir/im_outbox.gif" border=0 width=37 height=52 alt="$imtxt{'2'}"></a><a href="$cgi&action=im"><img src="$imagesdir/im_reload.gif" border=0 width=37 height=52 alt="$imtxt{'3'}"></a><a href="$cgi&action=imprefs"><img src="$imagesdir/im_config.gif" border=0 width=37 height=52 alt="$imtxt{'4'}"></a><img src="$imagesdir/im_right.gif" border=0 width=76 height=52>
</td>
</table>
<table border=0 width=100% cellspacing=1 bgcolor="#000000">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}"><b>$txt{'148'}</b></font></td>
 </tr>
 <tr>
  <td bgcolor="$color{'windowbg'}">
   <form action="$cgi&action=imsend2" method=post>
    <table border=0>
     <tr>
      <td>
       <font size=2><b>$txt{'150'}:</b></font>
      </td>
      <td>
       <font size=2><input type=text name="to" value="$INFO{'to'}" size="20" maxlength="50"></font>
      </td>
     </tr>
     <tr>
      <td>
       <font size=2><b>$txt{'70'}:</b></font>
      </td>
      <td>
       <font size=2><input type=text name="subject" value="$form_subject" size="40" maxlength="50"></font>
      </td>
     </tr>
     <tr>
      <td valign=top>
       <font size=2><b>$txt{'72'}:</b></font>
      </td>
      <td>
       <font size=2><textarea name=message rows=10 cols=50 wrap=physical>$form_message</textarea>
      </td>
     </tr>
     <tr>
      <td align=center colspan=2>
       <input type=submit value="$txt{'148'}">
       <input type=reset value="Reset Form">
      </td>
     </tr>
    </table>
   </form>
  </td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

#####
#
# Write new Message
#
#####

sub IMPost2 
{

	# Check Ignore-List

	if (-e("$memberdir/$FORM{'to'}.imconfig")) { 

		open(FILE, "$memberdir/$FORM{'to'}.imconfig");
		&lock(FILE);
		@imconfig = <FILE>;
		&unlock(FILE);
		close(FILE);

		# Build Ignore-List

		$imconfig[0] =~ s/[\n\r]//g;
		$imconfig[1] =~ s/[\n\r]//g;

		@ignore = split(/\|/,$imconfig[0]);

		# If User is on Recepients Ignor-List, show Error-Message
		
		foreach $igname (@ignore) {
			if ($igname eq $username) {
				&fatal_error("You are not allowed to send Instant Messages to this User!");
			}
		}

	}

	# Create unique Message ID = Time & ProccessID

	$messageid = $^T.$$;

	# ---

	$subject = $FORM{'subject'};
	$message = $FORM{'message'};
	
	&fatal_error("$txt{'77'}") unless($subject);
	&fatal_error("$txt{'78'}") unless($message);
	
	$mmessage = $message;
	$msubject = $subject;

	$subject =~ s/\&/\&amp;/g;
	$message =~ s/\&/\&amp;/g;
	$subject =~ s/"/\&quot;/g;
	$message =~ s/"/\&quot;/g;
	$subject =~ s/  / \&nbsp;/g;
	$message =~ s/  / \&nbsp;/g;
	
	$subject =~ s/</&lt;/g;
	$subject =~ s/>/&gt;/g;
	$subject =~ s/\|/\&#124;/g;
	$message =~ s/</&lt;/g;
	$message =~ s/>/&gt;/g;
	$message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
	$message =~ s/\cM//g;
	$message =~ s/\n/<br>/g;
	$message =~ s/\|/\&#124;/g;
	
	if (!(-e("$memberdir/$FORM{'to'}.dat"))) { 
		&fatal_error("$txt{'149'}"); 
	}
	
	# Add message to outbox
	
	if(-e("$memberdir/$username.outbox")) { 
		open (FILE, ">>$memberdir/$username.outbox");
	} else { 
		open (FILE, ">$memberdir/$username.outbox");
	}

	&lock(FILE);
	print FILE "$FORM{'to'}\|$subject\|$date\|$message\|$messageid\|$ENV{'REMOTE_ADDR'}\n";
	&unlock(FILE);
	close (FILE);
	
	# Send message to user
	
	open (FILE, ">>$memberdir/$FORM{'to'}.msg");
	&lock(FILE);
	print FILE "$username\|$subject\|$date\|$message\|$messageid\|$ENV{'REMOTE_ADDR'}\n";
	&unlock(FILE);
	close(FILE);

	# Send notification

	if ($imconfig[1]==1) {

		open (FILE, "$memberdir/$FORM{'to'}.dat");
		&lock(FILE);
		@recepient = <FILE>;
		&unlock(FILE);
		close(FILE);

		$recepient[2] =~ s/[\n\r]//g; # get eMail-Adress

		if ($recepient[2] ne "") {

			&sendmail("$recepient[2]","New Instant-Message ($msubject)","($date) $settings[1] has sent you the following Instant Message:\n\n->*<-\n\n$mmessage\n\n->*<-");

		}

	}

	print "Location: $cgi\&action=im\n\n";
	exit;
}

#####
#
# Set Preferences
#
#####

sub IMPreferences {

	if ($username eq "Guest") { 
		&fatal_error("$txt{'147'}"); 
	}

	if (-e("$memberdir/$username.imconfig")) { 
		open(FILE, "$memberdir/$username.imconfig");
		&lock(FILE);
		@imconfig = <FILE>;
		&unlock(FILE);
		close(FILE);
	}

	$imconfig[0] =~ s/[\n\r]//g;
	$imconfig[0] =~ s/\|/\n/g;
	$imconfig[1] =~ s/[\n\r]//g;

	if ($imconfig[1]) {
		$sel0="";
		$sel1=" selected";
	} else {
		$sel0=" selected";
		$sel1="";
	}

	$imtxt{'1'} = "Preferences";
	$imtxt{'2'} = "Ignorelist";
	$imtxt{'3'} = "Add one Username on each line!";
	$imtxt{'4'} = "Notify by eMail";
	$imtxt{'5'} = "Save Preferences";
	$imtxt{'6'} = "Reset Form";
	$imtxt{'7'} = "Inbox";
	$imtxt{'8'} = "Outbox";
	$imtxt{'9'} = "New Message";
	$imtxt{'10'} = "Receive New Messages";
	
	&header;
	print <<"EOT";
<table border=0 width=100% cellspacing=0>
<tr>
<td valign=bottom>
<font size=2>
 <b><a href="$boardurl/YaBB.pl">$mbname</a>:
    <a href="$cgi&action=im">$txt{'144'}</a>: $imtxt{'1'}</b>
</font>
</td>
<td align=right>
EOT
	print "<img src=\"$imagesdir/im_left.gif\" border=0 width=16 height=52>";
	print <<"EOT";
<a href="$cgi&action=im"><img src="$imagesdir/im_inbox.gif" border=0 width=37 height=52 alt="$imtxt{'7'}"></a><a href="$cgi&action=imoutbox"><img src="$imagesdir/im_outbox.gif" border=0 width=37 height=52 alt="$imtxt{'8'}"></a><a href="$cgi&action=imsend"><img src="$imagesdir/im_new.gif" width=37 height=52 border=0 alt="$imtxt{'9'}"></a><a href="$cgi&action=im"><img src="$imagesdir/im_reload.gif" border=0 width=37 height=52 alt="$imtxt{'10'}"></a><img src="$imagesdir/im_right.gif" border=0 width=76 height=52>
</td>
</table>
<table border=0 width=100% cellspacing=1 bgcolor="#000000">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size=2 color="$color{'titletext'}"><b>$imtxt{'1'}</b></font></td>
 </tr>
 <tr>
  <td bgcolor="$color{'windowbg'}">
   <form action="$cgi&action=imprefs2" method=post>
    <table border=0>
     <tr>
      <td valign=top>
       <font size=2><b>$imtxt{'2'}:</b></font><br><font size=1>$imtxt{'3'}</font>
      </td>
      <td>
       <font size=2><textarea name=ignore rows=10 cols=50 wrap=virtual>$imconfig[0]</textarea></font>
      </td>
     </tr>
     <tr>
      <td valign=top>
       <font size=2><b>$imtxt{'4'}:</b></font>
      </td>
      <td>
       <font size=2>
        <select name="notify">
         <option value="0"$sel0>$txt{'164'}
         <option value="1"$sel1>$txt{'163'}
        </select>
       </font>
      </td>
     </tr>
     <tr>
      <td>
      	&nbsp;
      </td>
      <td>
       <input type=submit value="$imtxt{'5'}">
       <input type=reset value="$imtxt{'6'}">
      </td>
     </tr>     
    </table>
   </form>
  </td>
 </tr>
</table>
EOT
	&footer;
	exit;
	
}

sub IMPreferences2 {

	if($username eq "Guest") { 
	 	&fatal_error("$txt{'147'}"); 
	}

	$ignorelist = "$FORM{'ignore'}";
	$notify = "$FORM{'notify'}";

	$ignorelist =~ s/[\n\r]/\|/g;
	$ignorelist =~ s/\|\|/\|/g;
	$notify =~ s/[\n\r]//g;

	open(FILE, ">$memberdir/$username.imconfig");
	&lock(FILE);

	print FILE $ignorelist."\n";
	print FILE $notify."\n";

	&unlock(FILE);
	close(FILE);

	print "Location: $cgi\&action=imprefs\n\n";
	exit;
}

#####
#
# Send message to User
#
#####
		
sub sendmail {

	my ($to, $subject, $message) = @_;

	open (MAIL, "|$mailprog -t");
	print MAIL "To: $to\n";
	print MAIL "From: $webmaster_email\n";
	print MAIL "Subject: $subject\n\n";
	print MAIL "$message";
	close(MAIL);

}

1;
